#!/usr/bin/python
#
# get-temp.py
# Read 1-wire temperature sensor
# Expect to have Sensor number as argument, return temp in degree C one decimal or
# on CRC error or missing sensor, returns "999".
# CF 160114
# Install 1-wire:
#http://www.raspberrypi-spy.co.uk/2013/03/raspberry-pi-1-wire-digital-thermometer-sensor/
#--------------------------------------
import sys

def gettemp(id):
    try:
        mytemp = ''
        filename = 'w1_slave'
        f = open('/sys/bus/w1/devices/' + id + '/' + filename, 'r')
        line = f.readline() # read 1st line
        crc = line.rsplit(' ',1)
        crc = crc[1].replace('\n', '')
        if crc=='YES':
            line = f.readline() # read 2nd line
            mytemp = line.rsplit('t=',1)
        
        else:
            mytemp = 199999
        f.close()
        
        return int(mytemp[1])
    
    except:
        return 199999



if __name__ == '__main__':
    # Direct call of script
    # print 'Argumenst= ',len(sys.argv),'first arg.is',sys.argv[1],' length',len(sys.argv[1]),'-'
    if (len(sys.argv) > 1) and ("28-" in sys.argv[1]) and (len(sys.argv[1]) == 15):
        #        id = sys.argv[1]
        #TEMP = '{:.1f}'.format(gettemp(id)/float(1000))
        TEMP = gettemp(sys.argv[1])
        if (TEMP == 199999):
            print 999
        else:
            TEMP = '{:.1f}'.format(TEMP/float(1000))
            print TEMP
    else:
        # print 'Missing or wrong argument of',len(sys.argv), ' arguments'
        print 999