#!/bin/bash
# Script dependent on get-ds1820.py to get Temp valueas and format it to Float and one decimal
# First install 1-wire DS18B20 sensor with kenerl support and w1-gpio/w1-therm
# For any sensor you want to use: add a User Variable in Domoticz with same name that the sensor
# unique number: example 28-0215618024ff, and of type Float
# This script will fetch all User varianles and for all that start with "28-" (wich are DS-18b20 sensor)
# it will get the temperature and update the user variable.
# Carlos F 20160116
#
# Use "crontab -e" to run this script every xx minits. Example: */10 * * * * /home/pi/update-temp-var.sh
#Change to your IP number.

# Domoticz server
SERVER="'':''@192.168.0.5:8080"
#SERVER="'':''@127.0.0.1:8080"

# Make arrays with User-variables: names, type and index. Only for names that start with "28-" e.g. DS18B20 sensors
declare -a namearray
declare -a typearray
declare -a idxarray
# Get a sting with all Users variables
UserVars=`curl -s  -i -H "Accept: application/json" "http://$SERVER/json.htm?type=command&param=getuservariables"`
# debug! echo $UserVars
# Strip of LF character:
UserVars=$(echo  "$UserVars" | tr '\n' ";")
# Make and array using separator " e.g. separate text strings
IFS='"' read -a XXarray <<< "$UserVars"
# Get length of array
arraylength=${#XXarray[@]}
# use for loop to read all names types and indexes
ii=0
for (( i=1; i<${arraylength}+1; i++ ));
do
    if [ "${XXarray[$i-1]}" == "Name" ]
    then
        if [[ ${XXarray[$i+1]} == "28-"* ]]
        # if varaible name start with "28-" then save name/type/index in array
        then
            ii=${#namearray[@]}
            namearray[$ii]="${XXarray[$i+1]}"
            typearray[$ii]="${XXarray[$i+5]}"
            idxarray[$ii]="${XXarray[$i+13]}"
        fi
    fi
done

# Get nuber of sensors tp update
arraylength=${#namearray[@]}
##echo $arraylength
# use for loop to read Temp and update User Variable
for (( i=0; i<${arraylength}; i++ ));
do
    UV_name=${namearray[$i]}
    UV_type=1  #Force type to Float! Otherwise variable type is in typearray[$i]
    UV_idx=${idxarray[$i]}
    UV_value=`python /home/pi/get-ds1820.py  $UV_name`
    # test if correct temp, py script gives 999 on error
    if [ "999" != $UV_value ]; then
    echo "Sensor "$UV_name": Temp= "$UV_value" C "
        # Send data, update User variables:
        curl -s -i -H "Accept: application/json" "http://$SERVER/json.htm?type=command&param=updateuservariable&idx=$UV_idx&vname=$UV_name&vtype=$UV_type&vvalue=$UV_value"
        curl -s -i -H "Accept: application/json" "http://$SERVER/json.htm?type=command&param=addlogmessage&message=Temp-script:%20Updated%20User%20Variable%20$UV_name"
    else
        curl -s -i -H "Accept: application/json" "http://$SERVER/json.htm?type=command&param=addlogmessage&message=Temp-script:%20Error%20reading%20sensor%20for%20variable%20$UV_name"
        echo "Error reading sensor "$file
    fi

done


